// -*-java-*-
// $Id: geocode.js,v 1.2 2007/08/19 03:16:21 asc Exp $

// http://www.aaronland.info/weblog/2007/07/28/trees/#delmaps
// Copyright (c) 2007 Aaron Straup Cope. All Rights Reserved.
// This is free software, you may use it and distribute it under the
// same terms as Perl itself.


function onFindNearbyPlaceName(json){
    var geo = json.geonames[0];
    geonames_hierarchy(geo.geonameId);
}

function onHierarchy(json){
    var geo = json.geonames;
    var cnt = geo.length;
    var tags = new Array();

    for (var i=0; i < cnt; i++){
        var name = geo[i].name;
        tags.push(delmaps_tagify(name));
    }

    do_post(tags);
}

function geonames_hierarchy(id){
    var url = "http://ws.geonames.org/hierarchyJSON?callback=onHierarchy&geonameId=" + encodeURIComponent(id);
    delmaps_JSR(url);
}

function geonames_findNearbyPlaceName(lat, lon){
    var url = "http://ws.geonames.org/findNearbyPlaceNameJSON?callback=onFindNearbyPlaceName";
    url += "&lat=" + encodeURIComponent(lat);
    url += "&lng=" + encodeURIComponent(lon);

    delmaps_JSR(url);
}

