// -*-java-*-
// $Id: store.js,v 1.5 2007/08/23 04:49:32 asc Exp $

// http://www.aaronland.info/weblog/2007/07/28/trees/#delmaps
// Copyright (c) 2007 Aaron Straup Cope. All Rights Reserved.
// This is free software, you may use it and distribute it under the
// same terms as Perl itself.

var resultMarker = function(){
    return map.getMarkerObject('result_marker');
};

var resultMarkerPos = function(mrk){
    
    if (! mrk){
        mrk = resultMarker();
    }

    return mrk.YGeoPoint;
};

var reportPosition = function(mrk){
    
    if (! mrk){
        mrk = resultMarker();
    }
    
    return mrk.getCoordPoint(); 
};

function setMarkerPosition(mrk, geo){
    // delmaps_report(mrk);
    mrk.setYGeoPoint(geo);
    // delmaps_report(mrk);
}

function resetMarker(){
    var mrk = resultMarker();
    // delmaps_log("reset result marker '" + mrk.id + "'");

    var coord = reportPosition(mrk);
    
    // WTF : PLEASE FUCKING BE SMART ENOUGH TO KNOW WHAT YOUR FUCKING OFFSET IS!!!!
    var point = new YCoordPoint(coord.x, coord.y + mrk.Image.size.height);
    var geo   = map.convertXYLatLon(point);

    setMarkerPosition(mrk, geo);
    return false;
};

function onEndDrag(){
    resetMarker();
}

var setMarker = function(pos, addr){
    map.removeMarker('result_marker');
    var mrk = new YMarker(pos, null, 'result_marker');

    // http://tango.freedesktop.org/Tango_Icon_Gallery
    mrk.addLabel("<img src=\"img/help-browser.png\" height=\"16\" width=\"16\" style=\"margin-top:3px;margin-left:4px;\"/>");

    mrk.Address = addr;

    YEvent.Capture(mrk, EventsList.MouseDoubleClick, onMarkerDoubleClick);
    map.addOverlay(mrk, 'result_overlay');
    makeMarkerDraggable(mrk);
};

function makeMarkerDraggable(mrk){
    var dd = new YAHOO.util.DD(mrk);
    dd.endDrag = onEndDrag;
}

var onMarkerDoubleClick = function(){
    var pos = resultMarkerPos();
    var lat = pos.Lat;
    var lon = pos.Lon;
    geonames_findNearbyPlaceName(lat, lon);
}

function do_post(tags){

    var mrk = resultMarker();
    var pos = resultMarkerPos(mrk);
    var lat = Number(pos.Lat).toFixed(6);
    var lon = Number(pos.Lon).toFixed(6);
    
    tags.push("del:bookmark=geo");
    tags.push("geo:lat=" + lat);
    tags.push("geo:lon=" + lon);

    gt = new Geotude({'latitude':lat,'longitude':lon});
    geotude = gt.geotude();

    if (geotude[0]){
        tags.push('geotude:major=' + geotude[0]);
        tags.push('geotude:minor=' + geotude[1]);
    }

    var str_tags = tags.join(" ");
    // delmaps_log(str_tags);

    rb = new Restobook();
    rb_addr = rb.address(mrk.Address);

    var uri   = encodeURIComponent("http://del.icio.us/tag/del:bookmark=geo#" + lat + "," + lon);
    var notes = encodeURIComponent(rb_addr);
    var str_tags = encodeURIComponent(str_tags);
    var title = encodeURIComponent(mrk.Address);

    send_post(uri, notes, str_tags, title);
};

function send_post (uri, notes, tags, title){

    if (! deluser){
        // WTF : because posting directly to /post strips the tag-love...
        deluser = prompt("Your del.icio.us username");
    }

    var post = "http://del.icio.us/" + deluser + "?v=4&noui&jump=close&url=" + uri + "&notes=" + notes + "&tags=" + tags + "&title=" + title;
    load_iframe(post);
}

// make me a private thingy...

function load_iframe (src){

    var ifr = document.getElementById("delframe");
    
    if (! ifr){
        ifr = document.createElement("iframe");
        ifr.setAttribute("id", "delframe");
        ifr.setAttribute("name", "delframe");
        ifr.setAttribute("style", "height:450;width:700;position:absolute;top:20;left:450;border:none");
        document.body.appendChild(ifr);
    }

    ifr.setAttribute("src", src);
    return;
};

function myOnEndGeoCode (res){
    
    if (! res.success){
        delmaps_log("Search did not yield any results");
        return
    }

    // WTF???!!! WHAT IS TRIGGERING THIS...
    if (map._lastGeoCode == res.Address){
        return;
    }

    var search = 0; 

    if (document.forms['queryform'].search){
        search = document.forms['queryform'].search.checked;
    }

    var zoom = (search) ? 5 : 2;
    
    if (search != 'on'){
        map.removeMarkersAll();
    }

    map._lastGeoCode = res.Address;

    var pos = res.GeoPoint;
    pos.Address = res.Address;

    map.drawZoomAndCenter(pos, zoom);

    if (search){
        return;
    }

    if (resultMarker()){
        resetMarker();
    }
    
    else {
        setMarker(pos, res.Address);
    }

    doYelpSearch(pos.Lat, pos.Lon);
}

function editMarker(b_url){
    url = atob(b_url);
    src = del_edit_url(url);
    load_iframe(src);
}

function del_edit_url(url){
    url = decodeURIComponent(url);	
    enc_url = encodeURIComponent(url);

    url = "http://del.icio.us/straup?url=" + enc_url + "&jump=close";
    return url;
}
