// -*-java-*-
// $Id: tags.js,v 1.2 2007/08/18 18:19:45 asc Exp $

function dmTags (list) {
         this._raw = list;
         this._tags = new Array();

    	ignore = new Array('del:bookmark=geo');
        var re = new RegExp("(?:" + ignore.join("|") + ")");

        this._raw.sort();

        var geo = {'lat':'', 'lon':''};
        var geotude = '';

        var stz = new sanitize();

        for (var i in this._raw){
            var str_tag = this._raw[i];

            if (re.exec(str_tag)){
                continue;
            }

            var user = document.getElementById('user');       

            var cl_tag = stz.sanitize_url_string(str_tag);
            var cl_user = stz.sanitize_url_string(user.value);

            var link = "javascript:void(load_tag('" + cl_user + "','" + cl_tag + "'));";
            var tag  = new dmTag(str_tag, link);
            
            if (mt = tag.MachineTag){
                ns = mt.namespace();

                if (ns=='geo'){                
                	var pred = mt.predicate();
                	geo[pred] = mt.value();
                        continue;
                }

                if ((ns=='geotude') && (mt.predicate()=='major')){
                    	geotude = mt.raw();
                        continue;
                }

                continue;
            }
            
            this._tags.push(tag);
        }

        if (geotude){
                var cl_geotude = stz.sanitize_url_string(geotude);
                var link = "javascript:void(load_tag('" + cl_user + "','" + cl_geotude + "'));";
            	var tag  = new dmTag('nearby-ish', link);
            	this._tags.push(tag);
        }

}

dmTags.prototype.tags = function () {
    return this['_tags'];
};

dmTags.prototype.asHTML = function () {
    var dom = this.asDOM();
    return dom.innerHTML;
};

dmTags.prototype.asDOM = function () {

    var list = this.tags();

    var div = document.createElement("div");
    var ul = document.createElement("ul");
    ul.setAttribute("class", "delmaps_taglist");

    for (var i in list){
        var tag = list[i];
        var li = document.createElement("li");
        li.setAttribute("class", "delmaps_taglist_tag");
        li.appendChild(tag.asDOM());
        ul.appendChild(li);
    }

    div.appendChild(ul);
    return div;
};

function dmTag (raw, link) {
         this._raw = raw;
         this._tag = raw;
         this._link = link;

         var mt = new MachineTag(raw);
         
         if (mt.is_machinetag()){
             this.MachineTag = mt;
             this._tag = mt.value();
         }
}

dmTag.prototype.asHTML = function () {
    var dom = this.asDOM();
    return dom.innerHTML();
};

dmTag.prototype.asDOM = function () {
    var stz = new sanitize();

    var a = document.createElement("a");
    a.setAttribute("href", this._link);
    a.setAttribute("onclick", "skip=1;");
    a.appendChild(document.createTextNode(stz.sanitize_string(this._tag)));
    return a;
};
