// -*-java-*-
// $Id: yelp.js,v 1.2 2007/08/07 02:35:36 asc Exp $

function Yelp (ywsid) {
    this._endpoint = 'http://api.yelp.com/';
    this._ywsid = ywsid;
}

Yelp.prototype.search = function (args) {
    this.execute_request('business_review_search', args)
};

Yelp.prototype.execute_request = function (method, args) {

    args['ywsid'] = this._ywsid;

    query = this.mk_querystring(args);
    var url = this._endpoint + method + "?" + query

    var jsr = new JSONscriptRequest(url);
    jsr.buildScriptTag(); 
    jsr.addScriptTag();
};

Yelp.prototype.mk_querystring = function (args) {

    var parts = new Array()

    for (key in args){
            parts.push(key + "=" + encodeURIComponent(args[key]));
    }

    return parts.join("&");
};
