// -*-java-*-
// $Id: barcode.js,v 1.3 2007/08/21 07:36:14 asc Exp $

function dmGenerateBarcodeCarouselId(url){
    var id = btoa(url);
    id = id.replace(/=/g, "");
    return "carousel_" + id;
}

function dmBarcode(url){
    this._url = url;
    this._id = "barcode_" + btoa(url);
}

dmBarcode.prototype.id = function(){
    return this._id;
};

dmBarcode.prototype.draw = function(){
    var data = {'url':this._url, 'size':3, 'use_images':1};
    return Semafox.Format.Table(data);
};

dmBarcode.prototype.asHTML = function(){
    var dom = this.asDOM();
    return dom.innerHTML;
};

dmBarcode.prototype.asDOM = function(){

    var container = document.createElement("div");
    var barcontainer = document.createElement("div");

    //barcontainer.setAttribute("class", "barcode");
    barcontainer.setAttribute("id", this.id());
    
    var semacode = this.draw();
    barcontainer.innerHTML = semacode['data'];

    container.appendChild(barcontainer);
    return container;
};
