// -*-java-*-
// $Id: init.js,v 1.3 2007/08/25 18:31:28 asc Exp $

// http://www.aaronland.info/weblog/2007/07/28/trees/#delmaps
// Copyright (c) 2007 Aaron Straup Cope. All Rights Reserved.
// This is free software, you may use it and distribute it under the
// same terms as Perl itself.

function delmaps_init(map){
    YEvent.Capture(map, EventsList.onEndGeoCode, myOnEndGeoCode);
    map.setMapType(YAHOO_MAP_REG);
    map.addTypeControl();
    map.addZoomShort();
}

function delmaps_JSR(url){
    // delmaps_log("do JSR : "+ url);

    var jsr = new JSONscriptRequest(url);
    jsr.buildScriptTag(); 
    jsr.addScriptTag();
}

function delmaps_tagify(str){
    str = str.toLowerCase();
    str = str.split(" ").join("");
    return str;
}

function delmaps_log(str){
    var log = document.getElementById("log");

    if (! log){
        log = document.createElement("p");
        log.setAttribute("id", "log");
        document.body.appendChild(log);
    }

    stz = new sanitize();
    cl_str = stz.sanitize_string(str);

    log.innerHTML = str + "<br />" + log.innerHTML;
}

function delmaps_report(marker){
    var id = marker.id;

    var point = marker.getCoordPoint();
    var spot = map.convertXYLatLon(point);

    var x = point.x;
    var y = point.y;

    var lat = spot.Lat;
    var lon = spot.Lon;

    // delmaps_log("[" + id + "] x:" +x + " y:" + y + " lat:" + lat + " lon:" + lon);
}
