// -*-java-*-
// $Id: machinetag.js,v 1.1 2007/08/09 15:26:13 asc Exp $

// http://www.aaronland.info/javascript/machinetag/
// http://www.aaronland.info/weblog/2007/07/28/trees/#delmaps

// Copyright (c) 2007 Aaron Straup Cope. All Rights Reserved.
// This is free software, you may use it and distribute it under the
// same terms as Perl itself.

function MachineTag (raw) {
    this._raw = raw;
    this._mt = 0;

    var re = new RegExp(/^([a-z](?:[a-z0-9_]+))\:([a-z](?:[a-z0-9_]+))\=(.*)/i);

    if (m = re.exec(raw)){
        this._namespace = m[1];
        this._predicate = m[2];
        this._value = m[3];
        this._mt = 1;       
    }
};

MachineTag.prototype.is_machinetag = function () {
    return this._mt;
};

MachineTag.prototype.namespace = function () {
    return this._namespace;
};

MachineTag.prototype.predicate = function () {
    return this._predicate;
};

MachineTag.prototype.value = function () {
    return this._value;
};

MachineTag.prototype.raw = function () {
    return this._raw;
};
